//------------------------------------------------------------------------------
// Cabecalho
//------------------------------------------------------------------------------
using namespace std;

//------------------------------------------------------------------------------
// Metodos
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Inicializa os atributos
//------------------------------------------------------------------------------
void MainForm::init()
{
  aberto = false;
  salvo = false;
  animado = false;
  ff = false;
  
  fronteira = new FrontForm(this);
  restricoes = new RestrForm(this);
  dados = new DadosForm(this);
}

//------------------------------------------------------------------------------
// Limpa os campos da interface
//------------------------------------------------------------------------------
void MainForm::fileNew()
{
  // Zera Parametros Gerais
  NomeScriptEdit->clear();
  SaidaComboBox->setCurrentItem(0);
  
  // Zera Parametros Ambiente
  AcelEdit1->clear(); AcelEdit2->clear(); AcelEdit3->clear();
  VelEdit1->clear(); VelEdit2->clear(); VelEdit3->clear();
  GamaEdit->clear(); 
  //PesoEdit->clear(); 
  FluidoEdit->clear();
  FluidoEdit1->clear(); FluidoEdit2->clear(); FluidoEdit3->clear();
    
  // Zera Parametros Malha
  MassaEdit->clear(); GradeEdit1->clear(); GradeEdit2->clear();
  EtaEdit1->clear(); EtaEdit2->clear(); EtaEdit3->clear(); EtaEdit4->clear();
  QsiEdit1->clear(); QsiEdit2->clear(); QsiEdit3->clear(); QsiEdit4->clear();
  PsiEdit1->clear(); PsiEdit2->clear(); PsiEdit3->clear(); PsiEdit4->clear();
    
  // Zera Parametros Tempo
  TempoEdit->clear(); QuadrosEdit->clear(); PulaEdit->clear();
    
  // Zera Parametros Objeto
  ObjetoComboBox->setCurrentItem(0); atualizaStack();
  PlanoEdit1->clear(); PlanoEdit2->clear(); PlanoEdit3->clear();
  fronteira->FrontEdit1->clear(); fronteira->FrontEdit2->clear();
  fronteira->FrontEdit3->clear(); fronteira->FrontEdit4->clear();
  fronteira->FrontEdit5->clear(); fronteira->FrontEdit6->clear();
  fronteira->FrontEdit7->clear(); fronteira->FrontEdit8->clear();
  fronteira->FrontEdit9->clear(); fronteira->FrontEdit10->clear();
  fronteira->FrontEdit11->clear(); fronteira->FrontEdit12->clear();
  restricoes->RestrTable->setNumRows(0); restricoes->RestrTable->setNumCols(8);
    
  // Zera Parametros Outros
   Delta_t_Edit->clear(); 
   //Delta_B_Edit->clear();
    
  aberto = false;
  salvo = false;
}
//------------------------------------------------------------------------------
// Faz a leitura do script
//------------------------------------------------------------------------------
void MainForm::fileOpen()
{
  // Variáveis Auxiliares
  bool ok;
  
  // Seleção do Arquivo
//  QString path = "/net/gorda.dca.fee.unicamp.br/l/home03/msc/lpm/Qt/Desmo/scripts_leandro";
  QString path = "./../scripts";  
  QString s = QFileDialog::getOpenFileName(path,
        "Arquivo de Script (script.*)",
        this,
        "open file dialog",
        "Escolha um Script" );
    
  // Caso o botão cancel seja pressionado
  if(s == NULL) return;
  
  //Limpa todos os campos primeiro para evitar que lixo permaneça no novo script
  fileNew();
    
  // Abertura do Script
  ifstream in(s);
    
  if (animado)
    {
      // Chamar o destrutor da classe Malha Aqui !!
      delete tecido;
    }
  
  // Escreve somente o nome do script
  int pos = s.findRev("/");
  s = s.remove(0,pos+1);
  NomeScriptEdit->setText(s);  
  
  // Leitura do Script
  char temp[30];
  
  // Leitura de saida - NAO ESTOU USANDO NA VERSAO 1.0
  do in >> temp;
  while (strcmp(temp,"saida")!=0);
  in >> temp; in >>temp;
    
  // Leitura de delta_t e delta_B
  do in >> temp;
  while (strcmp(temp,"delta_t")!=0);
  in >> temp; in >> temp;
  Delta_t_Edit->setText(temp);
  do in >> temp;
  while (strcmp(temp,"delta_B")!=0);
  in >> temp; in >> temp;
//  Delta_B_Edit->setText(temp);
  
  // Leitura de n_passos, pula e tempo_animacao
  do in >> temp;
  while (strcmp(temp,"n_passos")!=0);
  in >> temp; in >> temp;
  QuadrosEdit->setText(temp);
  do in >> temp;
  while (strcmp(temp,"pula")!=0);
  in >> temp; in >> temp;
  PulaEdit->setText(temp);
  do in >> temp;
  while (strcmp(temp,"tempo_animacao")!=0);
  in >> temp; in >> temp;
  TempoEdit->setText(temp);
    
  // Leitura de grid
  do in >> temp;
  while (strcmp(temp,"grid")!=0);
  in >> temp; in >> temp;
  GradeEdit1->setText(temp);
  in >> temp;
  GradeEdit2->setText(temp);
    
  // Leitura da aceleracao, velocidade e peso
  do in >> temp;
  while (strcmp(temp,"aceleracao")!=0);
  in >> temp; in >> temp; in >> temp; in >> temp;
  AcelEdit1->setText(temp);
  in >> temp; in >> temp; in >> temp;
  AcelEdit2->setText(temp);
  in >> temp; in >> temp; in >> temp;
  AcelEdit3->setText(temp);
  do in >> temp;
  while (strcmp(temp,"velocidade")!=0);
  in >> temp; in >> temp; in >> temp; in >> temp;
  VelEdit1->setText(temp);
  in >> temp; in >> temp; in >> temp;
  VelEdit2->setText(temp);
  in >> temp; in >> temp; in >> temp;
  VelEdit3->setText(temp);
  do in >> temp;
  while (strcmp(temp,"peso")!=0);
  in >> temp; in >> temp; in >> temp; in >> temp;
//  PesoEdit->setText(temp);
    
  // Leitura de eta, qsi, psi
  do in >> temp;
  while (strcmp(temp,"eta")!=0);
  in >> temp; in >> temp;
  EtaEdit1->setText(temp);
  in >> temp;
  EtaEdit2->setText(temp);
  in >> temp;
  EtaEdit3->setText(temp);
  in >> temp;
  EtaEdit4->setText(temp);
  do in >> temp;
  while (strcmp(temp,"qsi")!=0);
  in >> temp; in >> temp;
  QsiEdit1->setText(temp);
  in >>temp;
  QsiEdit2->setText(temp);
  in >>temp;
  QsiEdit3->setText(temp);
  in >>temp;
  QsiEdit4->setText(temp);
  do in >> temp;
  while (strcmp(temp,"psi")!=0);
  in >> temp; in >> temp;
  PsiEdit1->setText(temp);
  in >> temp;
  PsiEdit2->setText(temp);
  in >> temp;
  PsiEdit3->setText(temp);
  in >> temp;
  PsiEdit4->setText(temp);
    
  // Leitura de massa, gama e fluido
  do in >> temp;
  while (strcmp(temp,"massa")!=0);
  in >> temp; in >> temp;
  MassaEdit->setText(temp);
  do in >> temp;
  while (strcmp(temp,"gama")!=0);
  in >> temp; in >> temp;
  GamaEdit->setText(temp);
  do in >> temp;
  while ( (strcmp(temp,"fluido")!=0) && (strcmp(temp,"obj_deformavel")!=0)  );
  if(strcmp(temp,"fluido")==0) {
    in >> temp; in >> temp; in >> temp; in >> temp;
    FluidoEdit->setText(temp);
    in >> temp; in >> temp; in >> temp;
    FluidoEdit1->setText(temp);    
    in >> temp; in >> temp; in >> temp;
    FluidoEdit2->setText(temp);    
    in >> temp; in >> temp; in >> temp;
    FluidoEdit3->setText(temp);    
    do in >> temp;
    while (strcmp(temp,"obj_deformavel")!=0);
  }
    
  // Leitura de obj_deformavel
  in >> temp; in >> temp;
  if(strcmp(temp,"plane")==0 || strcmp(temp,"plano")==0 ) 
    {
      in >> temp;
      PlanoEdit1->setText(temp);
      in >> temp;
      PlanoEdit2->setText(temp);
      in >> temp;
      PlanoEdit3->setText(temp);
      ObjetoComboBox->setCurrentItem(1);
      atualizaStack();
    }
  else
    {
      // assumindo que na atual versão só tem plano e cilindro
      in >> temp;
      RayEdit->setText(temp);
      in >> temp;
      LengthEdit->setText(temp);
      ObjetoComboBox->setCurrentItem(2);
      atualizaStack();
    }
  // por aqui o código que atuliza os outros tipos de objeto fora o plano
    
  // Leitura de fronteira
  do in >> temp;
  while (strcmp(temp,"fronteira")!=0);
  in >> temp; in >> temp;
  fronteira->FrontEdit1->setText(temp);  
  in >> temp;
  fronteira->FrontEdit2->setText(temp);    
  in >> temp;
  fronteira->FrontEdit3->setText(temp); 
  in >> temp;
  fronteira->FrontEdit4->setText(temp); 
  in >> temp;
  fronteira->FrontEdit5->setText(temp);    
  in >> temp;
  fronteira->FrontEdit6->setText(temp); 
  in >> temp;
  fronteira->FrontEdit7->setText(temp); 
  in >> temp;
  fronteira->FrontEdit8->setText(temp); 
  in >> temp;
  fronteira->FrontEdit9->setText(temp);    
  in >> temp;
  fronteira->FrontEdit10->setText(temp); 
  in >> temp;
  fronteira->FrontEdit11->setText(temp); 
  in >> temp;
  fronteira->FrontEdit12->setText(temp); 
    
  // Leitura de restricoes
  do in >> temp;
  while (strcmp(temp,"n_restricoes")!=0);
  in >> temp; in >> temp;
  QString res(temp);

  int num_restr = res.toInt(&ok,10);
    
  if(num_restr>0)
    {
      restricoes->RestrTable->setNumRows(num_restr);
 
      do in >> temp;
      while (strcmp(temp,"restricoes")!=0);
      in >> temp; in >> temp;
      int aparicoes, posicao, u, v, inicio, fim;
      for(int j = 0; j < num_restr; j++) for(int i = 0; i < 8;i++) 
 {
   in >> temp;
   QString filtro(temp);
   aparicoes=filtro.contains('=',FALSE);
   if(aparicoes==0) 
     {
       restricoes->RestrTable->setText(j,i,filtro);  
  
       /*
  switch(i) 
  {
  case 0: u=filtro.toInt(&ok,10);
  tecido->restr[j].coord[0]=u;
  break;
  case 1: v=filtro.toInt(&ok,10);
  tecido->restr[j].coord[1]=v;
  break;
  case 2: tecido->restr[j].tipo = (filtro == "forca")  ? 3 : 1;
  break;
  }
       */
     }       
   else
     {
       posicao = filtro.findRev("=");
       filtro = filtro.remove(0,posicao+1);
       restricoes->RestrTable->setText(j,i,filtro); 
       /*
  switch(i) 
  {
  case 3: inicio=filtro.toInt(&ok,10);
  tecido->restr[j].inicio=inicio;
  break;
  case 4: fim=filtro.toInt(&ok,10);
  tecido->restr[j].fim=fim;
  break;
  case 5: tecido->restr[j].pe[0]=filtro.toDouble();
  break;
  case 6: tecido->restr[j].pe[1]=filtro.toDouble();
  break;
  case 7: tecido->restr[j].pe[2]=filtro.toDouble();
  break;
  }
       */
     }
 } // fim do for duplo
    } // fim do if as > 0   
    
  aberto = true;
}

//-------------------------------------------------------------------------------------
// Grava o script com nome
//-------------------------------------------------------------------------------------
void MainForm::fileSaveAs()
{
    // Seleção do arquivo
    QString s = QFileDialog::getSaveFileName(
     "/net/gorda.dca.fee.unicamp.br/l/home03/msc/lpm/eter/script_vanio",
     "Arquivo de Script (script.*)",
     this,
     "save file dialog",
     "Escolha um nome para o script" );
    
    // Caso o botão cancel seja pressionado
    if(s == NULL) return;
    
    // Cria e abre o arquivo de saída
    ofstream out(s);
    
    // Escreve o script
    out << "% Este script foi criado automaticamente pelo Desmo 1.0" << endl;
    out << "saida = " << SaidaComboBox->currentText() << endl;
    out << "delta_t = " << Delta_t_Edit->text() << endl;
//    out << "delta_B = " << Delta_B_Edit->text() << endl;
    out << "n_passos = " << QuadrosEdit->text() << endl;
    out << "pula = " << PulaEdit->text() << endl;    
    out << "tempo_animacao = " << TempoEdit->text() << endl;
    out << "grid : " << GradeEdit1->text() << " " << GradeEdit2->text() << endl;
    out << "aceleracao : x = " << AcelEdit1->text() << " y = " << AcelEdit2->text() 
     << " z = " << AcelEdit3->text() << endl;
    out << "velocidade : x = " << VelEdit1->text() << " y = " << VelEdit2->text()
     << " z = " << VelEdit3->text() << endl;
  //  out << "peso : p = " << PesoEdit->text() << endl;
    out << "eta : " <<EtaEdit1->text()<<" "<<EtaEdit2->text()<<" "<<EtaEdit3->text()<<" "<<EtaEdit4->text()<<endl;
    out << "qsi : " <<QsiEdit1->text()<<" "<<QsiEdit2->text()<<" "<<QsiEdit3->text()<<" "<<QsiEdit4->text()<<endl;
    out << "psi : " <<PsiEdit1->text()<<" "<<PsiEdit2->text()<<" "<<PsiEdit3->text()<<" "<<PsiEdit4->text()<<endl;
    out << "massa = " << MassaEdit->text() << endl;
    if(QString::compare(FluidoEdit->text(),""))
 out << "fluido : cte_forca_fluido = " <<FluidoEdit1->text()<<FluidoEdit2->text()<<FluidoEdit3->text()<<endl;    
    out << "gama = " << GamaEdit->text() << endl; 
    out << "obj_deformavel : " << ObjetoComboBox->currentText() << " " << PlanoEdit1->text() << " "  
     << PlanoEdit2->text() << " " << PlanoEdit3->text() << endl;     
    out << "fronteira : "<<fronteira->FrontEdit1->text()<<" "<<fronteira->FrontEdit2->text()<<" "<<
     fronteira->FrontEdit3->text()<<" "<<fronteira->FrontEdit4->text()<<" "<<
     fronteira->FrontEdit5->text()<<" "<<fronteira->FrontEdit6->text()<<" "<<
     fronteira->FrontEdit7->text()<<" "<<fronteira->FrontEdit8->text()<<" "<<
     fronteira->FrontEdit9->text()<<" "<<fronteira->FrontEdit10->text()<<" "<<
     fronteira->FrontEdit11->text()<<" "<<fronteira->FrontEdit12->text()<<endl;
    out << "n_restricoes = " << restricoes->RestrTable->numRows() << endl;
    out << "restricoes = {" << endl;    
    for(int j = 0; j < restricoes->RestrTable->numRows(); j++) for(int i = 0; i < 8;i++) 
    {
 out << restricoes->RestrTable->text(j,i) << " ";    
 if(i==2)
     out << "inicio=";
 else if(i==3)
     out << "fim=";
 else if(i==4)
     out << "x=";
 else if(i==5)
     out << "y=";
 else if(i==6)
     out << "z=";
 else if(i==7)
     out << endl;
    }
    
    out << "}" << endl;
    
    // Fecha o arquivo de saída
    out.close();
    
    // salvo = true; // para quando a função abaixo estiver pronta
    
}
//-------------------------------------------------------------------------------------
// Grava o script
//-------------------------------------------------------------------------------------
void MainForm::fileSave()
{
    if(!salvo) fileSaveAs();
    else 
    {
 
 // descarregar alterações no arquivo NomeScriptEdit->text();
 
    }
}
//-------------------------------------------------------------------------------------
// Atualiza o panel da tab objeto
//-------------------------------------------------------------------------------------
void MainForm::atualizaStack()
{
  switch(ObjetoComboBox->currentItem())
    {
    case 0: ObjetoStack->raiseWidget(0);
      break;
    case 1: ObjetoStack->raiseWidget(1);
      break;
    case 2: ObjetoStack->raiseWidget(2);
      break;
    }
}
//-------------------------------------------------------------------------------------
// Abre o form fronteira
//-------------------------------------------------------------------------------------
void MainForm::abreFrontForm()
{
    fronteira->exec();   
}
//-------------------------------------------------------------------------------------
// Abre o form restricoes 
//-------------------------------------------------------------------------------------
void MainForm::abreRestrForm()
{
    for(int coluna=0;coluna<restricoes->RestrTable->numCols();coluna++) 
 restricoes->RestrTable->adjustColumn(coluna);
    //restricoes->RestrTable->adjustSize();
    restricoes->exec();
}
//-------------------------------------------------------------------------------------
// Carrega os parametros da simulacao da interface na estrutura de dados
//-------------------------------------------------------------------------------------
void MainForm::carregaParametros()
{
   // Checar se os campos estao validos !!
    
    
   bool ok;
   
   tecido = new Malha((GradeEdit1->text()).toInt(&ok,10),(GradeEdit2->text()).toInt(&ok,10),MetodoComboBox->currentItem());
  
    
   // Carrega parametros tab Ambiente 
   tecido->acel[0] = (AcelEdit1->text()).toDouble();
   tecido->acel[1] = (AcelEdit2->text()).toDouble();
   tecido->acel[2] = (AcelEdit3->text()).toDouble();
   tecido->vel[0] = (VelEdit1->text()).toDouble();
   tecido->vel[1] = (VelEdit2->text()).toDouble();  
   tecido->vel[2] = (VelEdit3->text()).toDouble();
//   tecido->p = (PesoEdit->text()).toDouble();
   tecido->gama = (GamaEdit->text()).toDouble();

   if (!FluidoEdit->text().isEmpty())
     {
       tecido->fluido = 1;
       tecido->c_fluido = (FluidoEdit->text()).toDouble();
       tecido->u[0] = (FluidoEdit1->text()).toDouble();
       tecido->u[1] = (FluidoEdit2->text()).toDouble();
       tecido->u[2] = (FluidoEdit3->text()).toDouble();
     }

   // Carrega parametros tab Malha
   tecido->na[0] = (GradeEdit1->text()).toInt(&ok,10);
   tecido->na[1] = (GradeEdit2->text()).toInt(&ok,10);
   tecido->eta[0][0] = (EtaEdit1->text()).toDouble();
   tecido->eta[0][1] = (EtaEdit2->text()).toDouble();
   tecido->eta[1][0] = (EtaEdit3->text()).toDouble();    
   tecido->eta[1][1] = (EtaEdit4->text()).toDouble();
   tecido->qsi[0][0] = (QsiEdit1->text()).toDouble();
   tecido->qsi[0][1] = (QsiEdit2->text()).toDouble();    
   tecido->qsi[1][0] = (QsiEdit3->text()).toDouble();    
   tecido->qsi[1][1] = (QsiEdit4->text()).toDouble();
   tecido->psi[0][0] = (PsiEdit1->text()).toDouble();
   tecido->psi[0][1] = (PsiEdit2->text()).toDouble();    
   tecido->psi[1][0] = (PsiEdit3->text()).toDouble();    
   tecido->psi[1][1] = (PsiEdit4->text()).toDouble();    
   tecido->mi = (MassaEdit->text()).toDouble();
    
    // Carrega parametros tab Tempo
    tecido->n_passos = (QuadrosEdit->text()).toInt(&ok,10);
    tecido->pula = (PulaEdit->text()).toInt(&ok,10);
    tecido->tempo_animacao = (TempoEdit->text()).toDouble();
    
    // Carrega parametros tab Objeto
    if (ObjetoComboBox->currentItem()==1)
      {
	tecido->objeto = 0;
	tecido->comp_x_plano=(PlanoEdit1->text()).toDouble();
	tecido->comp_y_plano=(PlanoEdit2->text()).toDouble();
	tecido->comp_z_plano=(PlanoEdit3->text()).toDouble();
      }
    else
      {
	tecido->objeto = 2;
	tecido->raio_cilindro = (RayEdit->text()).toDouble();
	tecido->comp_cilindro = (LengthEdit->text()).toDouble();
      }

    
    // Carrega Fronteira
    tecido->k[0]=(fronteira->FrontEdit1->text()).toDouble();
    tecido->k[1]=(fronteira->FrontEdit2->text()).toDouble();
    tecido->k[2]=(fronteira->FrontEdit3->text()).toDouble();
    tecido->k[3]=(fronteira->FrontEdit4->text()).toDouble();
    tecido->k[4]=(fronteira->FrontEdit5->text()).toDouble();
    tecido->k[5]=(fronteira->FrontEdit6->text()).toDouble();
    tecido->k[6]=(fronteira->FrontEdit7->text()).toDouble();
    tecido->k[7]=(fronteira->FrontEdit8->text()).toDouble();
    tecido->k[8]=(fronteira->FrontEdit9->text()).toDouble();
    tecido->k[9]=(fronteira->FrontEdit10->text()).toDouble();
    tecido->k[10]=(fronteira->FrontEdit11->text()).toDouble();
    tecido->k[11]=(fronteira->FrontEdit12->text()).toDouble();
    
    // Carrega Restrições
    tecido->n_restricoes=restricoes->RestrTable->numRows();
    tecido->restr=new STR_REST[tecido->n_restricoes];
    
    for(int linha=0;linha<restricoes->RestrTable->numRows();linha++) 
    { 
 tecido->restr[linha].coord[0] = (restricoes->RestrTable->text(linha,0)).toInt(&ok,10);
 tecido->restr[linha].coord[1] = (restricoes->RestrTable->text(linha,1)).toInt(&ok,10);
 tecido->restr[linha].tipo = ((restricoes->RestrTable->text(linha,2))=="forca")  ? 3 : 1;
 tecido->restr[linha].inicio = (restricoes->RestrTable->text(linha,3)).toInt(&ok,10);
 tecido->restr[linha].fim = (restricoes->RestrTable->text(linha,4)).toInt(&ok,10);        

 if(tecido->restr[linha].tipo==3)
 {
     tecido->restr[linha].pe[0] = (restricoes->RestrTable->text(linha,5)).toDouble();
     tecido->restr[linha].pe[1] = (restricoes->RestrTable->text(linha,6)).toDouble();
     tecido->restr[linha].pe[2] = (restricoes->RestrTable->text(linha,7)).toDouble();
 }
 else
 {
     tecido->restr[linha].integra_x[0] =(restricoes->RestrTable->text(linha,5)).toInt(&ok,10);
     tecido->restr[linha].integra_x[1] =(restricoes->RestrTable->text(linha,6)).toInt(&ok,10);
     tecido->restr[linha].integra_x[2] = (restricoes->RestrTable->text(linha,7)).toInt(&ok,10);
 }
    }
    
    // Carrega parametros tab Outros
    tecido->delta_t = (Delta_t_Edit->text()).toDouble();
//    tecido->delta_B = (Delta_B_Edit->text()).toDouble();
}
//-------------------------------------------------------------------------------------
// Gera a animação
//-------------------------------------------------------------------------------------
void MainForm::geraAnimacao()
{
  int a;    
  
  if(aberto) 
    { 
      if(animado)
 {
   //delete(tecido);
   delete(Atler);
 }
    
      //tecido = new Malha;       
      carregaParametros();
      
      printf("\nGerando a animação...\n");
      
      //tecido->modelo=explicito; 
      //tecido->inicializa();
      
      tecido->gera_superficie_inicial();


      //      puts("OK ate aqui");

      Atler = new Render(0, tecido, MaterialComboBox->currentItem());

      //      a = MetodoComboBox->currentItem(); 

      // Alterar qdo o codigo estiver OK
      // Atler->metodo = MetodoComboBox->currentItem(); 

      //      Atler->metodo = 0;

      Atler->estatico = false;
 
      Atler->setGeometry(16, 110, 600, 600);

      QProgressBar barra;

      barra.setProgress(0);

      Atler->show();
      
      barra.setProgress(100);

      animado = true;
    } 
    
}
//-------------------------------------------------------------------------------------
// Grava em arquivo os dados de um quadro 
//-------------------------------------------------------------------------------------
void grava_quadro_arquivo(QString arquivo, Malha *tecido)   
{
    int pos;    
    
    // Path sem quota
    QString path="/net/gorda.dca.fee.unicamp.br/l/dsk14/prosim/work/lpm/quadro"+arquivo;
    //QString path="tmp/quadro"+arquivo;
    
    ofstream out(path);
    
    // Escrevendo parametros de QuadroTable
    if(arquivo=="1")
    {
      out <<  tecido->area0 <<  tecido->mi0 <<  endl; 
    }
    else
    {
      out << tecido->area <<  tecido->mi <<  endl;
    }
   
/*    
    // Escrevendo a posicao dos pontos
    for(int i=0;i<tecido->na[0];i++) for(int j=0;j<tecido->na[1];j++)
    {
 pos=i*tecido->na[1]+j;
 
// out << tecido->r[0]->ve[pos] << " " << tecido->r[1]->ve[pos] << " " << tecido->r[2]->ve[pos] << endl;
 
    }
    
    // Escrevendo as matrizes do sistema (primeiro f e g)
    for(int i=0;i<tecido->na[0];i++) for(int j=0;j<tecido->na[1];j++)
    {
 pos=i*tecido->na[1]+j;
 
 out << tecido->f[0]->ve[pos] << " " << tecido->f[1]->ve[pos] << " " << tecido->f[2]->ve[pos] << endl;
 out << tecido->g[0]->ve[pos] << " " << tecido->g[1]->ve[pos] << " " << tecido->g[2]->ve[pos] << endl;    }
    
    for(int linha=0;linha<tecido->na[0]*tecido->na[1];linha++) 
 for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++)
 {
 out << tecido->K->me[linha][coluna] << " ";
 out << tecido->A->me[linha][coluna] << endl;
    }         
    
  */  
    
    
    
    out.close();
}
//-------------------------------------------------------------------------------------
// Gera dados da animacao 
//-------------------------------------------------------------------------------------
void MainForm::geraDados()
{
/*     QString aux; */
/*     int pos, i1, i2, frame=1, quadros, item=0; */
/*     double base1[3], base2[3], prod[3]; */
    
/*     if(aberto)  */
/*     {  */
/*  carregaParametros(); */
 
/*  printf("\nGerando os dados...\n");        */
 
/*  // Quadros da animacao */
/*  quadros = tecido->n_passos/tecido->pula; */
 
/*  // Fluxo 1 */
/*  tecido->modelo=0; */
/* //        tecido->inicializa(); */
/*  tecido->gera_superficie_inicial(); */
 
/*  // Grava superficie inicial */
/*  //printf("\n %lf, %lf, %lf \n",tecido->f[0]->ve[60],tecido->f[1]->ve[60],tecido->f[2]->ve[60]);        */
 
/*  // printf("\n%d, %d, %d\n",tecido->f[60]->ve[0],tecido->f[60]->ve[1],tecido->f[60]->ve[2]);              */
/*  // Preence a tabela QuadroTable */
/*  aux = QString::number(tecido->area0); */
/*  dados->QuadroTable->setText(0,1,aux); */
/*  aux = QString::number(tecido->mi0);     */
/*  dados->QuadroTable->setText(1,1,aux); */
/*  aux = QString::number(tecido->gama0);     */
/*  dados->QuadroTable->setText(2,1,aux); */
 
/*  tecido->contador=1; */
 
/*  for(int quadro=1; quadro<tecido->n_passos; quadro++) */
/*  { */
/*      tecido->contador = tecido->contador+1; */
     
/*      // Fluxo 2 */
/* /\*      tecido->monta_K(); *\/ */
/*      //printf("\n\npós-fluxo 2\n\n");           */
     
/*      // Fluxo 3 */
/*      tecido->monta_restricoes(tecido->restr, tecido->n_restricoes, tecido->na); */
/*      //printf("\n\npós-fluxo 3\n\n");           */
     
/*      // Fluxo 4 */
/*      tecido->gera_f();  */
/*      //printf("\n\npós-fluxo 4\n\n");                     */
     
     
     
/*      if(quadro==1) */
/*      { */
/*        grava_quadro_arquivo(QString::number(frame),tecido); */
/*        // Insere o quadro inicial em quadrosComboBox */
/*        dados->quadrosComboBox->insertItem(QString::number(frame)+"/"+QString::number(quadros),item++);              */
/*        frame++; */
/*      } */
     
/*      if(quadro%tecido->pula == 0)  */
/*      { */
/*        grava_quadro_arquivo(QString::number(frame),tecido); */
/*        dados->quadrosComboBox->insertItem(QString::number(frame)+"/"+QString::number(quadros),item++); */
/*        frame++; */
/*      } */
     
/*      // Fluxo 5 */
/*      //          tecido->resolve_sistema_Euler(); */
/*      tecido->resolve_sistema_explicito(); */
     
/*      // Fluxo 6 */
/*      tecido->gera_normal(); */
     
/*  } */
 
 
/*  dados->intervalo = 1; // Checar depois os casos em que é preciso truncar */
 
/*  dados->tecido = tecido; */
 
/*  // Mostra o MatrizForm Populado */
/*  dados->carrega_quadro(); */
/*  //dados->carega_listas(); */
 
 
/*  dados->exec();  */
 
/*     } // Fim do if aberto?     */
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::populaDados()
{
    /*    
    QString aux;
    
    // Inicializacao das tabelas das matrizes K, A, G, F       
    dados->DadosTable->setNumCols(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizKTable->setNumCols(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizKTable->setNumRows(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizATable->setNumCols(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizATable->setNumRows(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizGTable->setNumRows(tecido->na[0]*tecido->na[1]);
    dados->matrizes->matrizFTable->setNumRows(tecido->na[0]*tecido->na[1]);
    
    // Preence a tabela QuadroTable
    aux = QString::number(tecido->area0);
    dados->QuadroTable->setText(0,1,aux);
    aux = QString::number(tecido->mi0);    
    dados->QuadroTable->setText(1,1,aux);
    aux = QString::number(tecido->gama0);    
    dados->QuadroTable->setText(2,1,aux);
    
    // Preenche a tabela DadosTable
    for(int i=0;i<tecido->na[0];i++) for(int j=0;j<tecido->na[1];j++)
    {
       pos = i*tecido->na[1]+j;
       
       // Imprime posicoes dos pontos
       aux = QString::number(tecido->r[0]->ve[pos]);
       dados->DadosTable->setText(0,pos,aux);
       aux = QString::number(tecido->r[1]->ve[pos]);    
       dados->DadosTable->setText(1,pos,aux);
       aux = QString::number(tecido->r[2]->ve[pos]);    
       dados->DadosTable->setText(2,pos,aux);
       
       // Imprime o vetor base em relacao ao eixo x
       tecido->diff(i,j,0,base1);
       aux = QString::number(base1[0]);
       dados->DadosTable->setText(3,pos,aux);
       aux = QString::number(base1[1]);    
       dados->DadosTable->setText(4,pos,aux);
       aux = QString::number(base1[2]);    
       dados->DadosTable->setText(5,pos,aux);
       
       // Imprime o vetor base em relacao ao eixo y
       tecido->diff(i,j,1,base2);
       aux = QString::number(base2[0]);
       dados->DadosTable->setText(6,pos,aux);
       aux = QString::number(base2[1]);    
       dados->DadosTable->setText(7,pos,aux);
       aux = QString::number(base2[2]);    
       dados->DadosTable->setText(8,pos,aux);
       
       // Imprime o vetor normal resultado do produto vetorial dos vetores de base
       prod[0]=0; prod[1]=0; prod[2]=0;
       for(int c=0;c<3;c++)
    {
        i1=(c+1)%3;
        i2=(c+2)%3;
        prod[c]=(base1[i1]*base2[i2]-base1[i2]*base2[i1]);
    }
    aux = QString::number(prod[0]);
    dados->DadosTable->setText(9,pos,aux);
    aux = QString::number(prod[1]);    
    dados->DadosTable->setText(10,pos,aux);
    aux = QString::number(prod[2]);    
    dados->DadosTable->setText(11,pos,aux);
    
    // Imprime o vetor normal utilizado
    aux = QString::number(tecido->dados[pos].n[0]);
    dados->DadosTable->setText(12,pos,aux);
    aux = QString::number(tecido->dados[pos].n[1]);    
    dados->DadosTable->setText(13,pos,aux);
    aux = QString::number(tecido->dados[pos].n[2]);    
    dados->DadosTable->setText(14,pos,aux);
    
    // Imprime os componentes do tensor métrico
    aux = QString::number(tecido->dados[pos].G[0][0]);
    dados->DadosTable->setText(15,pos,aux);
    aux = QString::number(tecido->dados[pos].G[0][1]);    
    dados->DadosTable->setText(16,pos,aux);
    aux = QString::number(tecido->dados[pos].G[1][0]);    
    dados->DadosTable->setText(17,pos,aux);
    aux = QString::number(tecido->dados[pos].G[1][1]);    
    dados->DadosTable->setText(18,pos,aux);
    
    // Imprime os componentes do tensor curvatura
    aux = QString::number(tecido->dados[pos].B[0][0]);
    dados->DadosTable->setText(19,pos,aux);
    aux = QString::number(tecido->dados[pos].B[0][1]);    
    dados->DadosTable->setText(20,pos,aux);
    aux = QString::number(tecido->dados[pos].B[1][0]);    
    dados->DadosTable->setText(21,pos,aux);
    aux = QString::number(tecido->dados[pos].B[1][1]);    
    dados->DadosTable->setText(22,pos,aux);
    
    // Imprime o determinando da matriz formada pelos coeficientes do tensor métrico
    aux = QString::number(tecido->dados[pos].area);
    dados->DadosTable->setText(23,pos,aux);
    
    // Imprime os componentes do tensor métrico recíproco    
    aux = QString::number(tecido->dados[pos].InvG[0][0]);    
    dados->DadosTable->setText(24,pos,aux);
    aux = QString::number(tecido->dados[pos].InvG[0][1]);    
    dados->DadosTable->setText(25,pos,aux);
    aux = QString::number(tecido->dados[pos].InvG[1][0]);    
    dados->DadosTable->setText(26,pos,aux);
    aux = QString::number(tecido->dados[pos].InvG[1][1]);    
    dados->DadosTable->setText(27,pos,aux);
    
    // Imprime os componentes do diferencial de Gauss
    aux = QString::number(tecido->dados[pos].D[0][0]);    
    dados->DadosTable->setText(28,pos,aux);
    aux = QString::number(tecido->dados[pos].D[0][1]);    
    dados->DadosTable->setText(29,pos,aux);
    aux = QString::number(tecido->dados[pos].D[1][0]);    
    dados->DadosTable->setText(30,pos,aux);
    aux = QString::number(tecido->dados[pos].D[1][1]);    
    dados->DadosTable->setText(31,pos,aux);    
    
    // Imprime os valores dos Simbolos de Cristoffel
    aux = QString::number(tecido->dados[pos].SC[0][0][0]);    
    dados->DadosTable->setText(32,pos,aux);
    aux = QString::number(tecido->dados[pos].SC[0][0][1]);    
    dados->DadosTable->setText(33,pos,aux);
    aux = QString::number(tecido->dados[pos].SC[0][1][0]);    
    dados->DadosTable->setText(34,pos,aux);
    aux = QString::number(tecido->dados[pos].SC[0][1][1]);    
    dados->DadosTable->setText(35,pos,aux);    
    aux = QString::number(tecido->dados[pos].SC[1][0][0]);    
    dados->DadosTable->setText(36,pos,aux);
    aux = QString::number(tecido->dados[pos].SC[1][0][1]);    
    dados->DadosTable->setText(37,pos,aux);
    aux = QString::number(tecido->dados[pos].SC[1][1][0]);    
    dados->DadosTable->setText(38,pos,aux);    
    aux = QString::number(tecido->dados[pos].SC[1][1][1]);    
    dados->DadosTable->setText(39,pos,aux);    
    
    // Imprime as derivadas de segunda ordem
    tecido->ediff(i,j,0,0,prod);
    aux = QString::number(prod[0]);
    dados->DadosTable->setText(40,pos,aux);
    aux = QString::number(prod[1]);    
    dados->DadosTable->setText(41,pos,aux);
    aux = QString::number(prod[2]);    
    dados->DadosTable->setText(42,pos,aux);
    tecido->ediff(i,j,0,1,prod);
    aux = QString::number(prod[0]);
    dados->DadosTable->setText(43,pos,aux);
    aux = QString::number(prod[1]);    
    dados->DadosTable->setText(44,pos,aux);
    aux = QString::number(prod[2]);    
    dados->DadosTable->setText(45,pos,aux);
    tecido->ediff(i,j,1,0,prod);
    aux = QString::number(prod[0]);
    dados->DadosTable->setText(46,pos,aux);
    aux = QString::number(prod[1]);    
    dados->DadosTable->setText(47,pos,aux);
    aux = QString::number(prod[2]);    
    dados->DadosTable->setText(48,pos,aux);
    tecido->ediff(i,j,1,1,prod);
    aux = QString::number(prod[0]);
    dados->DadosTable->setText(49,pos,aux);
    aux = QString::number(prod[1]);    
    dados->DadosTable->setText(50,pos,aux);
    aux = QString::number(prod[2]);    
    dados->DadosTable->setText(51,pos,aux);
    
    
    // Imprime os elementos G_N
    aux = QString::number(tecido->dados[pos].G_N[0][0]);    
    dados->DadosTable->setText(52,pos,aux);
    aux = QString::number(tecido->dados[pos].G_N[0][1]);    
    dados->DadosTable->setText(53,pos,aux);
    aux = QString::number(tecido->dados[pos].G_N[1][0]);    
    dados->DadosTable->setText(54,pos,aux);
    aux = QString::number(tecido->dados[pos].G_N[1][1]);    
    dados->DadosTable->setText(55,pos,aux);
    
    // Imprime os elementos B_T
    aux = QString::number(tecido->dados[pos].B_T[0][0]);    
    dados->DadosTable->setText(56,pos,aux);
    aux = QString::number(tecido->dados[pos].B_T[0][1]);    
    dados->DadosTable->setText(57,pos,aux);
    aux = QString::number(tecido->dados[pos].B_T[1][0]);    
    dados->DadosTable->setText(58,pos,aux);
    aux = QString::number(tecido->dados[pos].B_T[1][1]);    
    dados->DadosTable->setText(59,pos,aux);
    
    // Imprime os elementos N
    aux = QString::number(tecido->N[0]->me[0][pos]);    
    dados->DadosTable->setText(60,pos,aux);
    aux = QString::number(tecido->N[0]->me[1][pos]);    
    dados->DadosTable->setText(61,pos,aux);
    aux = QString::number(tecido->N[1]->me[0][pos]);    
    dados->DadosTable->setText(62,pos,aux);
    aux = QString::number(tecido->N[1]->me[1][pos]);    
    dados->DadosTable->setText(63,pos,aux);
    
    // Imprime os elementos M
    aux = QString::number(tecido->M[0]->me[0][pos]);    
    dados->DadosTable->setText(64,pos,aux);
    aux = QString::number(tecido->M[0]->me[1][pos]);
    dados->DadosTable->setText(65,pos,aux);
    aux = QString::number(tecido->M[1]->me[0][pos]);
    dados->DadosTable->setText(66,pos,aux);
    aux = QString::number(tecido->M[1]->me[1][pos]);
    dados->DadosTable->setText(67,pos,aux);
    
    // Imprime o vetor rest
    aux = QString::number(tecido->rest[pos]);
    dados->DadosTable->setText(68,pos,aux);
    
    // Imprime as matrizes f e g do quadro inicial em matrizes
    aux = QString::number(tecido->f[0]->ve[pos]);       
    dados->matrizes->matrizFTable->setText(pos,0,aux);
    aux = QString::number(tecido->f[1]->ve[pos]);       
    dados->matrizes->matrizFTable->setText(pos,1,aux);
    aux = QString::number(tecido->f[2]->ve[pos]);
    dados->matrizes->matrizFTable->setText(pos,2,aux);
    
    aux = QString::number(tecido->g[0]->ve[pos]);       
    dados->matrizes->matrizGTable->setText(pos,0,aux);
    aux = QString::number(tecido->g[1]->ve[pos]);       
    dados->matrizes->matrizGTable->setText(pos,1,aux);
    aux = QString::number(tecido->g[2]->ve[pos]);
    dados->matrizes->matrizGTable->setText(pos,2,aux);
    
      } // Fim for duplo
      
      for(int linha=0;linha<tecido->na[0]*tecido->na[1];linha++) 
  for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++)
  {
     aux = QString::number(tecido->K->me[linha][coluna]);       
     dados->matrizes->matrizKTable->setText(linha,coluna,aux);
     aux = QString::number(tecido->A->me[linha][coluna]);       
     dados->matrizes->matrizATable->setText(linha,coluna,aux);
  }         
      for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++) 
      {
  dados->matrizes->matrizKTable->adjustColumn(coluna);
  dados->matrizes->matrizATable->adjustColumn(coluna);
  dados->DadosTable->adjustColumn(coluna);
      }
      for(int coluna=0;coluna<3;coluna++) 
      {
  dados->matrizes->matrizGTable->adjustColumn(coluna);
  dados->matrizes->matrizFTable->adjustColumn(coluna);
      }
      
      */
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::filePrint()
{
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::fileExit()
{
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::helpIndex()
{
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::helpContents()
{
    
}
//-------------------------------------------------------------------------------------
// 
//-------------------------------------------------------------------------------------
void MainForm::helpAbout()
{
    
}
//-------------------------------------------------------------------------------------
/*
  for(int linha=0;linha<tecido->na[0]*tecido->na[1];linha++) 
  for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++)
  {
     aux = QString::number(tecido->K->me[linha][coluna]);       
     dados->matrizes->matrizKTable->setText(linha,coluna,aux);
     aux = QString::number(tecido->A->me[linha][coluna]);       
     dados->matrizes->matrizATable->setText(linha,coluna,aux);
  }   
      for(int coluna=0;coluna<tecido->na[0]*tecido->na[1];coluna++) 
      {
  dados->matrizes->matrizKTable->adjustColumn(coluna);
  dados->matrizes->matrizATable->adjustColumn(coluna);
  dados->DadosTable->adjustColumn(coluna);
      }
      for(int coluna=0;coluna<3;coluna++) 
      {
  dados->matrizes->matrizGTable->adjustColumn(coluna);
  dados->matrizes->matrizFTable->adjustColumn(coluna);
      }
      dados->exec(); 
      frame=1;
      grava_quadro_arquivo(QString::number(frame++));
      
      
      tecido->contador=0;
      
      for(int quadro=1; quadro<tecido->n_passos; quadro++) 
      {
  tecido->contador = tecido->contador+1;
  tecido->monta_K();
  tecido->monta_restricoes(tecido->restr, tecido->n_restricoes, tecido->na);
  tecido->gera_f(tecido->na); 
  tecido->resolve_sistema();
  if(quadro%tecido->pula == 0)
    grava_quadro_arquivo(QString::number(frame++));
  tecido->gera_normal(6,tecido->na);
  
      }  
      
      */



/* Impressao de Testes
   
    //TESTE
    printf("\nDelta_t = %f",tecido->delta_t);
    printf("\nDelta_B = %f",tecido->delta_B);
    
    //TESTE
    printf("\nPassos = %i ",tecido->n_passos);
    printf("\nPula = %i ",tecido->pula);
    printf("\nTempo Animacao = %f ",tecido->tempo_animacao);
    
    //TESTE
    printf("\nNa[0] = %i ",tecido->na[0]);
    printf("\nNa[1] = %i ",tecido->na[1]);
    
    //TESTE
    printf("\nAceleracao = %f %f %f",tecido->acel[0],tecido->acel[1],tecido->acel[2]);
    printf("\nVelocidade = %f %f %f",tecido->vel[0],tecido->vel[1],tecido->vel[2]);
    printf("\nPeso = %f",tecido->p);
    
    //TESTE
    printf("\nETA = %f %f %f %f",tecido->eta[0][0],tecido->eta[0][1],
     tecido->eta[1][0],tecido->eta[1][1]);
    printf("\nQSI = %f %f %f %f",tecido->qsi[0][0],tecido->qsi[0][1],
     tecido->qsi[1][0],tecido->qsi[1][1]);
    printf("\nPSI = %f %f %f %f",tecido->psi[0][0],tecido->psi[0][1],
     tecido->psi[1][0],tecido->psi[1][1]);
     
    //TESTE
    printf("\nObjeto = Plano (%i) | %f %f %f",tecido->objeto,tecido->comp_x_plano,
    tecido->comp_y_plano,tecido->comp_z_plano);
    
    //TESTE
    printf("\nFronteira: %f %f %f %f %f %f %f %f %f %f %f %f\n",tecido->k[0],
	   tecido->k[1],tecido->k[2],tecido->k[3],tecido->k[4],tecido->k[5],
	   tecido->k[6],tecido->k[7],tecido->k[8],tecido->k[9],tecido->k[10],tecido->k[11]);
	   
    //TESTE (dentro do if do fluido, antes da leitura do objeto deformavel)
    printf("\nFluido = %f  %f %f %f",tecido->c_fluido,tecido->u[0],tecido->u[1],tecido->u[2]);   
    
    //TESTE
    printf("\nMassa = %f",tecido->mi);
    printf("\nGama = %f",tecido->gama);
    
    // TESTE
    for(int j=0;j<as;j++) {
      printf("\nRestricao %d: U=%d V=%d Tipo=%d",j,tecido->restr[j].coord[0],
	     tecido->restr[j].coord[1],tecido->restr[j].tipo);    
      printf(" X=%f Y=%f Z=%f \n", tecido->restr[j].pe[0],tecido->restr[j].pe[1],
	     tecido->restr[j].pe[2]);
    }
    
*/





